/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
)

// checks if the AssetMedia type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AssetMedia{}

// AssetMedia struct for AssetMedia
type AssetMedia struct {
	Id *string `json:"id,omitempty"`
	Url *string `json:"url,omitempty"`
	Source AssetMediaSource `json:"source"`
	// Only in document (file) assets
	Filename *string `json:"filename,omitempty"`
}

// NewAssetMedia instantiates a new AssetMedia object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAssetMedia(source AssetMediaSource) *AssetMedia {
	this := AssetMedia{}
	this.Source = source
	return &this
}

// NewAssetMediaWithDefaults instantiates a new AssetMedia object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAssetMediaWithDefaults() *AssetMedia {
	this := AssetMedia{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *AssetMedia) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AssetMedia) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *AssetMedia) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *AssetMedia) SetId(v string) {
	o.Id = &v
}

// GetUrl returns the Url field value if set, zero value otherwise.
func (o *AssetMedia) GetUrl() string {
	if o == nil || IsNil(o.Url) {
		var ret string
		return ret
	}
	return *o.Url
}

// GetUrlOk returns a tuple with the Url field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AssetMedia) GetUrlOk() (*string, bool) {
	if o == nil || IsNil(o.Url) {
		return nil, false
	}
	return o.Url, true
}

// HasUrl returns a boolean if a field has been set.
func (o *AssetMedia) HasUrl() bool {
	if o != nil && !IsNil(o.Url) {
		return true
	}

	return false
}

// SetUrl gets a reference to the given string and assigns it to the Url field.
func (o *AssetMedia) SetUrl(v string) {
	o.Url = &v
}

// GetSource returns the Source field value
func (o *AssetMedia) GetSource() AssetMediaSource {
	if o == nil {
		var ret AssetMediaSource
		return ret
	}

	return o.Source
}

// GetSourceOk returns a tuple with the Source field value
// and a boolean to check if the value has been set.
func (o *AssetMedia) GetSourceOk() (*AssetMediaSource, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Source, true
}

// SetSource sets field value
func (o *AssetMedia) SetSource(v AssetMediaSource) {
	o.Source = v
}

// GetFilename returns the Filename field value if set, zero value otherwise.
func (o *AssetMedia) GetFilename() string {
	if o == nil || IsNil(o.Filename) {
		var ret string
		return ret
	}
	return *o.Filename
}

// GetFilenameOk returns a tuple with the Filename field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AssetMedia) GetFilenameOk() (*string, bool) {
	if o == nil || IsNil(o.Filename) {
		return nil, false
	}
	return o.Filename, true
}

// HasFilename returns a boolean if a field has been set.
func (o *AssetMedia) HasFilename() bool {
	if o != nil && !IsNil(o.Filename) {
		return true
	}

	return false
}

// SetFilename gets a reference to the given string and assigns it to the Filename field.
func (o *AssetMedia) SetFilename(v string) {
	o.Filename = &v
}

func (o AssetMedia) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AssetMedia) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if !IsNil(o.Url) {
		toSerialize["url"] = o.Url
	}
	toSerialize["source"] = o.Source
	if !IsNil(o.Filename) {
		toSerialize["filename"] = o.Filename
	}
	return toSerialize, nil
}

type NullableAssetMedia struct {
	value *AssetMedia
	isSet bool
}

func (v NullableAssetMedia) Get() *AssetMedia {
	return v.value
}

func (v *NullableAssetMedia) Set(val *AssetMedia) {
	v.value = val
	v.isSet = true
}

func (v NullableAssetMedia) IsSet() bool {
	return v.isSet
}

func (v *NullableAssetMedia) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAssetMedia(val *AssetMedia) *NullableAssetMedia {
	return &NullableAssetMedia{value: val, isSet: true}
}

func (v NullableAssetMedia) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAssetMedia) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


